'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactApollo = require('react-apollo');

var _Loading = require('../../../components/Loading');

var _Modals = require('../../../components/Modals');

var _api = require('../api');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function securedModalPage(props) {
  return function (WrappedComponent) {
    var SecuredPage = function SecuredPage(_ref) {
      var data = _ref.data,
          restProps = _objectWithoutProperties(_ref, ['data']);

      var loading = data.loading,
          error = data.error,
          checkPermission = data.checkPermission;


      if (loading) {
        return _react2.default.createElement(
          _Modals.ModalRoutePage,
          null,
          _react2.default.createElement(_Loading.Loading, null)
        );
      }

      if (!loading && !checkPermission) {
        return _react2.default.createElement(
          _Modals.ModalRoutePage,
          null,
          _react2.default.createElement(
            'p',
            null,
            'Forbidden'
          )
        );
      }

      if (!loading && error) {
        return _react2.default.createElement(
          _Modals.ModalRoutePage,
          null,
          _react2.default.createElement(
            'p',
            null,
            'Request error'
          )
        );
      }

      return _react2.default.createElement(WrappedComponent, restProps);
    };

    SecuredPage.propTypes = {
      data: _propTypes2.default.object.isRequired
    };

    return (0, _reactApollo.graphql)(_api.checkPermissionQuery, {
      options: {
        variables: { permission: props.permission },
        fetchPolicy: 'network-only'
      }
    })(SecuredPage);
  };
}

exports.default = securedModalPage;